const data = {"menu":{"AppContext":{"name":"AppContext","items":[]},"Server":{"name":"Server","items":[]},"analytics":{"name":"analytics","items":[{"name":"default"}]},"environment":{"name":"environment","items":[{"name":"isServer"},{"name":"isClient"}]},"fetch":{"name":"fetch","items":[{"name":"fetchWithCookies"},{"name":"default"}]},"fetchLatest":{"name":"fetchLatest","items":[{"name":"default"},{"name":"StaleResponseError"}]},"format":{"name":"format","items":[{"name":"price"}]},"launchClient":{"name":"launchClient","items":[]},"persist":{"name":"persist","items":[]},"withStyleProps":{"name":"withStyleProps","items":[]},"model":{"children":[{"name":"CartModelBase","items":[]},{"name":"SearchModelBase","items":[{"name":"ResultsModel"},{"name":"ResultsGroupModel"},{"name":"default"}]},{"name":"SearchResultsModelBase","items":[{"name":"FacetModelBase"},{"name":"FacetGroupModelBase"},{"name":"SortBase"},{"name":"default"}]}]},"personal":{"children":[{"name":"usePersonalization","items":[]},{"name":"withPersonalization","items":[]}]},"router":{"children":[{"name":"Router","items":[]},{"name":"cache","items":[]},{"name":"fromClient","items":[]},{"name":"fromServer","items":[{"name":"fetch"},{"name":"default"}]},{"name":"headers","items":[{"name":"SURROGATE_KEY"},{"name":"HANDLER"},{"name":"RESPONSE_TYPE"},{"name":"API_VERSION"},{"name":"REACT_STOREFRONT"},{"name":"XDN_VERSION"},{"name":"ROUTES"}]},{"name":"proxyUpstream","items":[]},{"name":"serviceWorker","items":[{"name":"cache"},{"name":"prefetchJsonFor"},{"name":"prefetch"},{"name":"abortPrefetches"},{"name":"resumePrefetches"},{"name":"configureCache"},{"name":"waitForServiceWorkerController"},{"name":"removeOldCaches"}]},{"name":"withGlobalState","items":[]}]},"utils":{"children":[{"name":"browser","items":[{"name":"isSafari"}]},{"name":"createGenerateClassName","items":[]},{"name":"dataProps","items":[]},{"name":"optimizeImages","items":[]},{"name":"scriptInjector","items":[{"name":"injectScriptInHead"},{"name":"injectCodeInHead"},{"name":"removeScriptInHead"},{"name":"removeCodeInHead"}]},{"name":"state","items":[{"name":"lazyState"},{"name":"parseState"}]},{"name":"url","items":[{"name":"relativeURL"},{"name":"absoluteURL"},{"name":"canUseClientSideNavigation"}]}]}},"exports":{"AppContext":{"name":"AppContext","async":false,"generator":false,"comments":"Allows you to import the global application context into components.\n\nContains the following properties:\n\n- app: The mobx-state-tree `AppModel` instance\n- history: The JS history instance\n- router: The router exported from `routes.js`\n- errorReporter: The global error reporter exported by `errorReporter.js`\n\nExample: Displaying a product using the app state tree\n\n```js\n import React, { useContext } from 'react'\n import { useObserver } from 'mobx-react-lite'\n import AppContext from 'react-storefront/AppContext'\n\n function Product() {\n   return useObserver(() => {\n     const { app: { product } } = useContext(AppContext)\n\n     return (\n       <div>\n         <h1>{product.name}</h1>\n       </div>\n     )\n   })\n }\n```","examples":[],"params":[],"returns":[],"import":"import AppContext from 'react-storefront/AppContext'"},"Server":{"name":"Server","type":"function","async":false,"generator":false,"comments":"Serves requests from the Moovweb platform.","examples":[],"params":[{"name":"$0","type":"Object","properties":[{"name":"theme"},{"name":"model"},{"name":"App"},{"name":"router"},{"name":"deferScripts","default":"true"},{"name":"transform"},{"name":"errorReporter","default":"Function.prototype"}]}],"returns":[],"import":"import Server from 'react-storefront/Server'","members":[{"name":"serve","type":"function","async":false,"generator":false,"comments":"Handles an isomorphic request by serving json, html, or amp content based on the URL.","examples":[],"params":[{"name":"request"},{"name":"response"}],"returns":[]},{"name":"setContentType","type":"function","async":false,"generator":false,"comments":"Sets the content type to application/json for json URLs, text/html for all others","examples":[],"params":[{"name":"request","type":"Object"},{"name":"response","type":"Response"}],"returns":[]},{"name":"renderPWA","type":"function","async":true,"generator":false,"comments":"Renders either a JSON or HTML response for the given state based on the path suffix.","examples":[],"params":[{"name":"options","type":"Object","properties":[{"name":"request","type":"Object","text":"The current request object"},{"name":"response","type":"Response","text":"The current response object"},{"name":"state","type":"Object","text":"The app state"},{"name":"history","type":"Object","text":"The js history object"}]}],"returns":[{"text":"The html for app"}]},{"name":"renderError","type":"function","async":false,"generator":false,"comments":"Renders an error response, either as JSON or SSR HTML, depending on the suffix\non the request path.","examples":[],"params":[{"name":"e","type":"Error"},{"name":"request","type":"Request"},{"name":"response","type":"Response"},{"name":"history"}],"returns":[]}]},"analytics/default":{"name":"analytics","type":"EventEmitter","async":false,"generator":false,"comments":"This module's default export is an `EventEmitter` for broadcasting analytics events to all targets configured via `<AnalyticsProvider>`.\n\nExample:\n\n```js\nimport analytics from 'react-storefront/analytics'\n\n// this will call the 'someEvent(data)' method on all configured targets and pass { foo: 'bar' } as the data argument.\nanalytics.fire('someEvent', { foo: 'bar' })\n```","examples":[],"params":[],"returns":[],"import":"import analytics from 'react-storefront/analytics'"},"environment/isServer":{"name":"isServer","type":"function","async":false,"generator":false,"comments":"Returns `true` only when called on the server.","examples":[],"params":[],"returns":[{"type":"Boolean"}],"import":"import { isServer } from 'react-storefront/environment'"},"environment/isClient":{"name":"isClient","type":"function","async":false,"generator":false,"comments":"Returns `true` only when called on the client.","examples":[],"params":[],"returns":[{"type":"Boolean"}],"import":"import { isClient } from 'react-storefront/environment'"},"fetch/fetchWithCookies":{"name":"fetchWithCookies","type":"function","async":false,"generator":false,"comments":"The same as fetch, but automatically relays the cookies passed in from the browser to the upstream API.","examples":[],"params":[{"name":"url","type":"String","text":"The url to fetch"},{"name":"options","default":"{}","type":"Object","text":"Options for fetch"},{"name":"qsOptions","type":"String","text":"Options for serializing the request body using the qs package"}],"returns":[{"type":"Promise"}],"import":"import { fetchWithCookies } from 'react-storefront/fetch'"},"fetch/default":{"name":"fetch","type":"function","async":false,"generator":false,"comments":"An implementation of the standard fetch API.  See https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API for options\n\nThis function is commonly used to fetch json data\n\n```js\nconst data = await fetch('https://jsonplaceholder.typicode.com/todos/1')\n  .then(res => res.json())\n```\n\nOr string data:\n\n```js\nconst text = await fetch('https://jsonplaceholder.typicode.com/todos/1')\n  .then(res => res.text())\n```\n\nYou can also use it to fetch binary data:\n\n```js\nconst buffer = await fetch('https://www.w3.org/WAI/ER/tests/xhtml/testfiles/resources/pdf/dummy.pdf')\n  .then(res => res.arrayBuffer())\n```\n\nIn addition to the standard fetch options, you can also specify:\n\n- `maxRedirects` - number - The maximum number of redirects that fetch will follow before returning an error.  Defaults to 20.\n- `acceptInvalidCerts` - boolean - Set to true to allow connections to sites with invalid SSL cers.","examples":[],"params":[{"name":"url","type":"String"},{"name":"options","default":"{}","type":"Object","text":"Options for fetch","properties":[{"name":"redirect","default":"manual","type":"Object","text":"\"manual\", \"follow\", or \"error\""},{"name":"maxRedirects","default":"20","type":"Object","text":"The maximum number of redirects that fetch will follow before returning an error.  Defaults to 20."},{"name":"acceptInvalidCerts","default":"false","type":"Object","text":"Set to true to allow connections to sites with invalid SSL cers."}]},{"name":"qsOptions","type":"Object","text":"Options for serializing the request body using the qs package"}],"returns":[{"type":"Promise"}],"import":"import fetch from 'react-storefront/fetch'"},"fetchLatest/default":{"name":"fetchLatest","type":"function","async":false,"generator":false,"comments":"Creates a fetch function with an internal incrementing request counter that ensures that out of order\nresponses result in a StaleResponseError.\n\nExample usage:\n\n```js\nimport { fetchLatest, StaleResponseError } from 'react-storefront/fetch'\n\nconst fetch = fetchLatest()\n\ntry {\n  const response = await fetch('/some/url')\n} catch (e) {\n  if (!StaleResponseError.is(e)) {\n    throw e // just ignore stale responses, rethrow all other errors\n  }\n}\n```","examples":[],"params":[{"name":"fetch"}],"returns":[{"type":"Function"}],"import":"import fetchLatest from 'react-storefront/fetchLatest'"},"fetchLatest/StaleResponseError":{"name":"StaleResponseError","type":"class","async":false,"generator":false,"comments":"Thrown when an out of order response is received","examples":[],"params":[],"returns":[],"import":"import { StaleResponseError } from 'react-storefront/fetchLatest'","members":[]},"format/price":{"name":"price","type":"function","async":false,"generator":false,"comments":"Formats a price for display","examples":[],"params":[{"name":"price","type":"Number"},{"name":"options","default":"{}","type":"Object","properties":[{"name":"currency","default":"'USD'"},{"name":"decimals","default":"2"},{"name":"locale","default":"'en-US'"}]}],"returns":[{"type":"String"}],"import":"import { price } from 'react-storefront/format'"},"launchClient":{"name":"launchClient","type":"function","async":false,"generator":false,"comments":"Bootstraps the PWA react application.","examples":[],"params":[{"name":"options","type":"options","properties":[{"name":"App","type":"React.Element","text":"The root app element"},{"name":"theme","type":"Object","text":"A material-ui theme"},{"name":"model","type":"Object","text":"A mobx-state-tree model class"},{"name":"target","default":"document.getElementById('root')","type":"HTMLElement","text":"The DOM element to mount onto"},{"name":"errorReporter","default":"Function.prototype","type":"Function","text":"A function to call when an error occurs so that it can be logged"},{"name":"router"}]}],"returns":[],"import":"import launchClient from 'react-storefront/launchClient'"},"persist":{"name":"persist","type":"function","async":false,"generator":false,"comments":"import { persist } from 'path/to/persist'\n\n export const ModelName = types\n  .model('ModelName', {\n    keyOne: 'includeMe',\n    keyTwo: 'excludeMe'\n  })\n  .actions(self => ({\n    afterCreate() {\n      persist('storageName', self, {\n        keyOne: true,\n      })\n    }\n  }))","examples":[],"params":[{"name":"name","type":"String","text":"The name of the item in storage"},{"name":"store","type":"Model","text":"The mobx state tree model to store"},{"name":"schema","default":"{}","type":"Object","text":"OPTIONAL object of model keys, used to limit what gets stored - all keys stored by default"}],"returns":[],"import":"import persist from 'react-storefront/persist'"},"withStyleProps":{"name":"withStyleProps","type":"function","async":false,"generator":false,"comments":"Decorator for mapping a component's props to JSS styles","examples":[],"params":[{"name":"styles","type":"Object"},{"name":"options"}],"returns":[{"type":"React.Component","text":"Example:\n\n import withStyleProps from 'react-storefront'\n import React, { Component } from 'react'"}],"import":"import withStyleProps from 'react-storefront/withStyleProps'"},"model/CartModelBase":{"name":"CartModelBase","type":"class","async":false,"generator":false,"comments":"A base model for the shopping cart","examples":[],"params":[],"returns":[],"import":"import CartModelBase from 'react-storefront/model/CartModelBase'","members":[{"name":"items","async":false,"generator":false,"comments":"The products in the cart.","examples":[],"params":[],"returns":[]},{"name":"quantity","type":"function","async":false,"generator":false,"comments":"The total number of items in the cart","examples":[],"params":[],"returns":[{"type":"Number"}]},{"name":"add","type":"function","async":false,"generator":false,"comments":"Adds a product to the cart","examples":[],"params":[{"name":"product","type":"ProductModelBase"}],"returns":[]},{"name":"remove","type":"function","async":false,"generator":false,"comments":"Removes a product from the cart","examples":[],"params":[{"name":"product","type":"ProductModelBase"}],"returns":[]}]},"model/SearchModelBase/ResultsModel":{"name":"ResultsModel","type":"constant","async":false,"generator":false,"comments":"Represents an individual link within a group","examples":[],"params":[],"returns":[],"import":"import { ResultsModel } from 'react-storefront/model/SearchModelBase'"},"model/SearchModelBase/ResultsGroupModel":{"name":"ResultsGroupModel","type":"constant","async":false,"generator":false,"comments":"Represents a group of links withing the search results","examples":[],"params":[],"returns":[],"import":"import { ResultsGroupModel } from 'react-storefront/model/SearchModelBase'"},"model/SearchModelBase/default":{"name":"SearchModelBase","type":"constant","async":false,"generator":false,"comments":"The base model for site-wide searches.","examples":[],"params":[],"returns":[],"import":"import SearchModelBase from 'react-storefront/model/SearchModelBase'"},"model/SearchResultsModelBase/FacetModelBase":{"name":"FacetModelBase","type":"constant","async":false,"generator":false,"comments":"A search facet that can be applied as a filter","examples":[],"params":[],"returns":[],"import":"import { FacetModelBase } from 'react-storefront/model/SearchResultsModelBase'"},"model/SearchResultsModelBase/FacetGroupModelBase":{"name":"FacetGroupModelBase","type":"constant","async":false,"generator":false,"comments":"A grouping of facets","examples":[],"params":[],"returns":[],"import":"import { FacetGroupModelBase } from 'react-storefront/model/SearchResultsModelBase'"},"model/SearchResultsModelBase/SortBase":{"name":"SortBase","type":"constant","async":false,"generator":false,"comments":"A value by which results can be sorted","examples":[],"params":[],"returns":[],"import":"import { SortBase } from 'react-storefront/model/SearchResultsModelBase'"},"model/SearchResultsModelBase/default":{"name":"SearchResultsModelBase","async":false,"generator":false,"comments":"A base class for search results and subcategories that supports filtering and sorting","examples":[],"params":[],"returns":[],"import":"import SearchResultsModelBase from 'react-storefront/model/SearchResultsModelBase'"},"personal/usePersonalization":{"name":"usePersonalization","type":"function","async":false,"generator":false,"comments":"A hook for fetching late-loaded personalized data.  This hook automatically\ncalls the `loadPersonalization()` method on the model in the specified `branch` in the app\nstate tree whenever the model's id field changes.\n\nExample\n\n```js\nfunction Product() {\n  usePersonalization(app => app.product)\n  return //...\n}\n```","examples":[],"params":[{"name":"branch","type":"Function","text":"A function that returns the model that should fetch personalized data."}],"returns":[{"type":"Function"}],"import":"import usePersonalization from 'react-storefront/personal/usePersonalization'"},"personal/withPersonalization":{"name":"withPersonalization","type":"function","async":false,"generator":false,"comments":"Provides the `usePersonalization` hook as a HOC/decorator. Use this if you're using classes,\nuse `usePersonalization` if you're using function components.\n\nExample\n\n```js","examples":[],"params":[{"name":"branch","type":"Function","text":"A function that returns the model that should fetch personalized data."}],"returns":[{"type":"Function"}],"import":"import withPersonalization from 'react-storefront/personal/withPersonalization'"},"router/Router":{"name":"Router","type":"class","async":false,"generator":false,"comments":"Provides routing for MUR-based applications and PWAs.  This class is inspired by express and uses https://github.com/rcs/route-parser,\nwhich supports sophisticated pattern matching including optional paths, params, and splatting.\n\nExample:\n```js\n const router = new Router()\n\n router.get('/products/:id', ({ id }) => {\n   // fetch product from upstream API (you'll need to write this function)\n   return fetchProduct(id).then(result => {\n     return result.product // this will be the result of router.run()\n   })\n })\n\n // assuming env.path = /products/1 and env.method = 'GET'\n router.run() // => the details for product 1\n```\n\nRoutes can be divided into multiple files to increase maintainability using the \"use()\" method.  For example:\n\n```js\n // /scripts/api/router.js\n\n const appShell = require('/build/index.html.js)\n\n module.exports = new Router()\n   .fallback(() => appShell) // render the PWA's app shell for all unmatched routes\n   .use('/products', require('/api/products.js'))\n```\n\n```js\n // /scripts/api/products.js\n\n module.exports = new Router()\n   .get('/:id', ({ id }) => new Promise((resolve, reject) => {\n     // fetch product from upstream API...\n    }))\n```\n\n```js\n // /scripts/index.js\n\n const router = require('/api/router')\n\n module.exports = function() {\n   // ...\n   router.run().then((result) => {\n     const body = typeof result === 'string' ? result : JSON.stringify(result)\n     sendResponse({ body, htmlparsed: true })\n   })\n }\n```\n\nRouter is an EventEmitting that fires the following events:\n\n- `before`: Fires before a route is run, passing an object containing `request` and `response`.\n- `after`: Fires after a route is run and all handlers have finised, passing an object containing `request` and `response`.\n- `fetch`: Fires when a `fromServer` handler runs on the client, resulting in a fetch from the server. No arguments are passed to the event handler.","examples":[],"params":[],"returns":[],"import":"import Router from 'react-storefront/router/Router'","members":[{"name":"get","type":"function","async":false,"generator":false,"comments":"Registers a GET route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"post","type":"function","async":false,"generator":false,"comments":"Registers a POST route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"patch","type":"function","async":false,"generator":false,"comments":"Registers a PATCH route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"put","type":"function","async":false,"generator":false,"comments":"Registers a PUT route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"delete","type":"function","async":false,"generator":false,"comments":"Registers a DELETE route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"options","type":"function","async":false,"generator":false,"comments":"Registers an OPTIONS route","examples":[],"params":[{"name":"path","type":"String","text":"A path pattern"},{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"fallback","type":"function","async":false,"generator":false,"comments":"Designates the handlers for unmatched routes","examples":[],"params":[{"name":"handlers"},{"name":"callback","type":"Function","text":"A function that returns a promise that resolves to the content to return"}],"returns":[{"type":"Router","text":"this"}]},{"name":"appShell","type":"function","async":false,"generator":false,"comments":"Defines the handler for the app-shell.  Generally this should be a single fromServer handler that return\nthe global data for menus and navigation and sets loading: true.  The app-shell is used in offline mode\nduring initial landing on an uncached SSR result.","examples":[],"params":[{"name":"handlers","type":"any","text":"Handlers that return patches to be merged into the app state"}],"returns":[{"type":"Router","text":"this"}]},{"name":"isAppShellConfigured","type":"function","async":false,"generator":false,"comments":"Returns `true` if `appShell` has been called to configure an appShell route, otherwise `false`.","examples":[],"params":[],"returns":[{"type":"Boolean"}]},{"name":"error","type":"function","async":false,"generator":false,"comments":"Sets the handler for errors thrown during route handling","examples":[],"params":[{"name":"handler","type":"Function","text":"A function that returns a promise that resolves to the content to return"}],"returns":[{"type":"Router","text":"this"}]},{"name":"use","type":"function","async":false,"generator":false,"comments":"Registers a set of nested routes.\n\nExample:\n\n Router root = new Router()\n\n Router products = new Router()\n products.get('/:id', ({ id }) => {\n   return Promise.resolve(id)\n })\n\n root.use('/products', products)\n\n // url: /products/1\n root.run().then(result => console.log(result)) // => 1","examples":[],"params":[{"name":"path","type":"String","text":"The parent path"},{"name":"router","type":"Router","text":"A router to handle the nested routes"}],"returns":[{"type":"Router","text":"this"}]},{"name":"configureClientCache","type":"function","async":false,"generator":false,"comments":"Configures service worker runtime caching options","examples":[],"params":[{"name":"options","type":"Object","properties":[{"name":"cacheName","type":"Object","text":"The name of the runtime cache"},{"name":"maxEntries","type":"Object","text":"The max number of entries to store in the cache"},{"name":"maxAgeSeconds","type":"Object","text":"The TTL in seconds for entries"}]}],"returns":[{"type":"Router","text":"this"}]},{"name":"getCacheKey","type":"function","async":false,"generator":false,"comments":"Gets the server cache key for the matching route.","examples":[],"params":[{"name":"request","type":"Object"},{"name":"defaults","type":"Object","text":"The default values used for the cache key"}],"returns":[{"type":"Object","text":"An object populate with keys and values that when hashed, make up the cache key"}]},{"name":"createLocation","type":"function","async":false,"generator":false,"comments":"Creates an object describing the browser location","examples":[],"params":[],"returns":[{"type":"Object"}]},{"name":"run","type":"function","async":true,"generator":true,"comments":"Runs the current url (from env) and generates a result from each the matching route's handlers.","examples":[],"params":[{"name":"request","type":"Object","text":"The request being served","properties":[{"name":"path","type":"String","text":"The url path"},{"name":"method","type":"String","text":"The http method"}]},{"name":"response","type":"Response","text":"The response object"},{"name":"options","default":"{}","type":"Object","properties":[{"name":"initialLoad","default":"false","type":"Boolean","text":"Set to true if this is the initial load of the application.  This will cause the HTML to be cached for the current path"},{"name":"historyState","default":"{}"}]}],"returns":[{"type":"Object","text":"Generates state objects"}]},{"name":"runAll","type":"function","async":true,"generator":false,"comments":"Runs all client and server handlers for the specified path and method","examples":[],"params":[{"name":"request","type":"Object","text":"The request being served","properties":[{"name":"path","type":"String","text":"The url path"},{"name":"method","type":"String","text":"The http method"}]},{"name":"response","type":"Response","text":"The response object"},{"name":"options","type":"Object"},{"name":"state","default":"{}","type":"Object","text":"The accumulated state from other handlers"}],"returns":[{"type":"Object","text":"The merged result of all handlers"}]},{"name":"toPromise","type":"function","async":false,"generator":false,"comments":"Converts specified callback to a promise","examples":[],"params":[{"name":"callback","type":"Function/Object","text":"A function that returns a Promise that\n resolves to the new state, a function that returns the new state, or the new state itself."},{"name":"params","type":"Object","text":"The request parameters"},{"name":"request","type":"Object","text":"The request object with body and headers"},{"name":"response","type":"Response","text":"The response object"}],"returns":[]},{"name":"findMatchingRoute","type":"function","async":false,"generator":false,"comments":"Returns the matching route and parsed params for the specified path and method","examples":[],"params":[{"name":"request","type":"Object","text":"The http request"}],"returns":[{"type":"Object","text":"an object with match and params"}]},{"name":"willNavigateToUpstream","type":"function","async":false,"generator":false,"comments":"Returns true if the URL points to a route that has a proxyUpstream handler.","examples":[],"params":[{"name":"url","type":"String","text":"The url to check"},{"name":"method","default":"'get'","type":"String"}],"returns":[{"type":"Boolean"}]},{"name":"fetchFreshState","type":"function","async":false,"generator":false,"comments":"Runs all client and server handlers for the specified location and returns state","examples":[],"params":[{"name":"location"}],"returns":[]},{"name":"onLocationChange","type":"function","async":false,"generator":false,"comments":"Called when the location is changed on the client","examples":[],"params":[{"name":"callback","type":"Function","text":"A callback to pass the new state to"},{"name":"location","type":"Object","text":"The new location"},{"name":"action"}],"returns":[]},{"name":"watch","type":"function","async":false,"generator":false,"comments":"Calls the specified callback whenever the current URL changes","examples":[],"params":[{"name":"history","type":"History"},{"name":"callback","type":"Function"}],"returns":[{"type":"Router","text":"this"}]},{"name":"applySearch","type":"function","async":false,"generator":false,"comments":"Provides an easy way to navigate by changing some but not all of the query params.  Any keys\nincluded in the params object are applied as new query param values.  All other query params are preserved.","examples":[],"params":[{"name":"params","type":"Object","text":"Key/value pairs to apply to the query string.  Specifying a value of undefined or null will remove that parameter from the query string"},{"name":"stringifyOptions","default":"{}","type":"Object","text":"Options of stringifying all query params.  Applied for `qs.stringify`: https://github.com/ljharb/qs#stringifying"}],"returns":[]}]},"router/cache":{"name":"cache","type":"function","async":false,"generator":false,"comments":"Specifies that the result of a route should be cached.  This handler must come before fromServer.\n\nExample:\n\n   router.get('/p/:id',\n     cache({\n       server: {\n         maxAgeSeconds: 300 // cache for 5 minutes on the server,\n         key: (request, defaults) => ({ // cache result separately for mobile and desktop user agents\n           ...defaults,\n           mobile: ['iOS', 'Android'].includes(\n             new UAParser(request.headers['user-agent']).getOS().name\n           )\n         })\n       },\n       client: true // cache in the service worker based on the settings passed to router.configureClientCache()\n     })\n     fromClient({ view: 'Product' }),\n     fromServer('./product.js'),\n   )","examples":[],"params":[{"name":"options","type":"Object","properties":[{"name":"server","type":"Number","properties":[{"name":"maxAgeSeconds","type":"Number","text":"The number of seconds the result should be cached on the server.  The maxAgeSeconds key is required when specifying a server config."},{"name":"key","type":"Function","text":"A function to compute a custom cache key for server-side caching.  The function is\n passed the request object and a defaults object containing the key/value pairs that make up the default cache key.  This function is optional when specifying a server config."}]},{"name":"client","type":"Boolean","text":"Set to true to cache on the client based on the configuration defined by router.configureClientCache(). Defaults to false."}]}],"returns":[{"type":"Object"}],"import":"import cache from 'react-storefront/router/cache'"},"router/fromClient":{"name":"fromClient","type":"function","async":false,"generator":false,"comments":"A handler that can be run on the client.  It will also be run on the server during server-side rendering.\n\nExample:\n\n\t\trouter.get('/p/:id',\n\t\t\tfromClient({ view: 'Product' }),\n\t\t\tfromServer('./product')\n\t\t)","examples":[],"params":[{"name":"callback","type":"Function/Object","text":"A function that takes the route params and returns an object to spply to the app state, or simply an object to spply to the app state."}],"returns":[{"type":"Object","text":"A handler spec"}],"import":"import fromClient from 'react-storefront/router/fromClient'"},"router/fromServer/fetch":{"name":"fetch","type":"function","async":true,"generator":false,"comments":"Fetch's state as json from the specified url","examples":[],"params":[{"name":"url","type":"String","text":"The url to fetch"},{"name":"options","default":"{}","type":"Object","properties":[{"name":"cache","default":"'default'","type":"String","text":"Set to \"force-cache\" to cache the response in the service worker.  Omit to skip the service worker cache."}]}],"returns":[{"type":"Object","text":"A state patch"}],"import":"import { fetch } from 'react-storefront/router/fromServer'"},"router/fromServer/default":{"name":"fromServer","type":"function","async":false,"generator":false,"comments":"Creates a handler that fetches data from the server.\n\nThe `handlerPath` should point to a module that exports a function that takes params, request, and response,\nand returns an object that should be applied to the app state.  For example:\n\n // routes.js\n router.get('/p/:id'\n   fromServer('./product/product-handler')\n )\n\n // product/product-handler.js\n export default function productHandler(params, request, response) {\n   return fetchFromUpstreamApi(`/products/${params.id}`)\n     .then(res => res.json())\n     .then(productData => ({ // the shape of this object should match your AppModel\n       page: 'Product',\n       product: productData\n     }))\n }\n\nWhen the request path ends in \".json\", the json response will be returned verbatim.  In all other cases, server-side rendered HTML\nwill be returned.\n\nYou can also send a verbatim string response using `response.send(body)`.  For example:\n\n // routes.js\n router.get('/my-api'\n   fromServer('./my-api-handler')\n )\n\n // my-api-handler.js\n export default function myApiHandler(params, request, response) {\n   response\n     .set('content-type', response.JSON)\n     .send(JSON.stringify({ foo: 'bar' }))\n }\n\nWhen `response.send()` is called in a handler, react-storefront will never perform server-side rendering.","examples":[],"params":[{"name":"handlerPath","type":"String","text":"The path to the module that exports a handler function that returns state to apply"},{"name":"getURL","type":"Function","text":"An optional function that returns the back end url to call when fetching.  You only need\n  to specify this if you want to override the default URL."}],"returns":[{"type":"Function"}],"import":"import fromServer from 'react-storefront/router/fromServer'"},"router/headers/SURROGATE_KEY":{"name":"SURROGATE_KEY","type":"string","async":false,"generator":false,"comments":"Response header which designates an surrogate key by which the response can be\nflushed from edge caches.\n\nValue: a string, defaults to the handler path but can be set by the user.","examples":[],"params":[],"returns":[],"import":"import { SURROGATE_KEY } from 'react-storefront/router/headers'"},"router/headers/HANDLER":{"name":"HANDLER","type":"string","async":false,"generator":false,"comments":"Response header containing the path to the handler as written in `fromServer`\n\nValue: a string like './home/home-handler'","examples":[],"params":[],"returns":[],"import":"import { HANDLER } from 'react-storefront/router/headers'"},"router/headers/RESPONSE_TYPE":{"name":"RESPONSE_TYPE","type":"string","async":false,"generator":false,"comments":"Response header that indicates whether the response was \"static\", \"json\", \"ssr\", or \"proxy\".\nUsed to gather metrics for different response types.\n\nValue: \"static\", \"json\", \"ssr\", or \"proxy\"","examples":[],"params":[],"returns":[],"import":"import { RESPONSE_TYPE } from 'react-storefront/router/headers'"},"router/headers/API_VERSION":{"name":"API_VERSION","type":"string","async":false,"generator":false,"comments":"Response header used by the service worker to ensure that responses are only served from the\ncache  corresponding to the current running version of the app.\n\nValue: a webpack hash","examples":[],"params":[],"returns":[],"import":"import { API_VERSION } from 'react-storefront/router/headers'"},"router/headers/REACT_STOREFRONT":{"name":"REACT_STOREFRONT","type":"string","async":false,"generator":false,"comments":"Response header whose presence indicates that the request was\nserved by react-storefront.\n\nValue: true","examples":[],"params":[],"returns":[],"import":"import { REACT_STOREFRONT } from 'react-storefront/router/headers'"},"router/headers/XDN_VERSION":{"name":"XDN_VERSION","type":"string","async":false,"generator":false,"comments":"Request header sent from the outer edge to indicate that the app is running\nbehind an outer edge.\n\nValue: a semver value.","examples":[],"params":[],"returns":[],"import":"import { XDN_VERSION } from 'react-storefront/router/headers'"},"router/headers/ROUTES":{"name":"ROUTES","type":"string","async":false,"generator":false,"comments":"Request header that when present will make RSF return a JSON summary of the routes.","examples":[],"params":[],"returns":[],"import":"import { ROUTES } from 'react-storefront/router/headers'"},"router/proxyUpstream":{"name":"proxyUpstream","type":"function","async":false,"generator":false,"comments":"A handler that fetches HTML from the same path as the current request on the upstream site. Use\nthis handler to transform HTML from the upstream site or return it unaltered.\n\nThe callback you provide is passed the following arguments:\n\nparams {Object} Request parameters parsed from the route and query string\nrequest {Object} An object representing the request\nresponse {Response} An object representing the response.  Call response.send(html) to send the resulting html back to the browser.\n\nTo use response from the upstream site unaltered, called response.send() with no arguments.","examples":[],"params":[{"name":"cb","default":"perfectProxy","type":"Function","text":"A callback which takes params, request, and response."}],"returns":[],"import":"import proxyUpstream from 'react-storefront/router/proxyUpstream'"},"router/serviceWorker/cache":{"name":"cache","type":"function","async":true,"generator":false,"comments":"Cache content using the service worker.  If content is not supplied, the service worker will fetch\nthe content from the server","examples":[],"params":[{"name":"path","type":"String","text":"The URI path of the request"},{"name":"cacheData","type":"String","text":"The data to cache"}],"returns":[],"import":"import { cache } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/prefetchJsonFor":{"name":"prefetchJsonFor","type":"function","async":true,"generator":false,"comments":"Prefetches and caches JSON for the specified path","examples":[],"params":[{"name":"path","type":"String","text":"A URL path for a page (without .json)"},{"name":"includeSSR"}],"returns":[],"import":"import { prefetchJsonFor } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/prefetch":{"name":"prefetch","type":"function","async":false,"generator":false,"comments":"Prefetches and caches SSR and JSON for the specified path","examples":[],"params":[{"name":"path","type":"String","text":"A URL path for a page (without .json)"}],"returns":[],"import":"import { prefetch } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/abortPrefetches":{"name":"abortPrefetches","type":"function","async":true,"generator":false,"comments":"Aborts all in progress prefetches.  Call this function to prevent prefetching from blocking\nmore important requests, like page navigation.","examples":[],"params":[],"returns":[],"import":"import { abortPrefetches } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/resumePrefetches":{"name":"resumePrefetches","type":"function","async":true,"generator":false,"comments":"Resume queued prefetch requests which were cancelled to allow for more important requests","examples":[],"params":[],"returns":[],"import":"import { resumePrefetches } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/configureCache":{"name":"configureCache","type":"function","async":true,"generator":false,"comments":"Configures runtime caching options","examples":[],"params":[{"name":"options","type":"Object","properties":[{"name":"cacheName","type":"Object","text":"The name of the runtime cache"},{"name":"maxEntries","type":"Object","text":"The max number of entries to store in the cache"},{"name":"maxAgeSeconds","type":"Object","text":"The TTL in seconds for entries"}]}],"returns":[],"import":"import { configureCache } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/waitForServiceWorkerController":{"name":"waitForServiceWorkerController","type":"function","async":true,"generator":false,"comments":"Resolves when the service worker has been installed","examples":[],"params":[],"returns":[],"import":"import { waitForServiceWorkerController } from 'react-storefront/router/serviceWorker'"},"router/serviceWorker/removeOldCaches":{"name":"removeOldCaches","type":"function","async":true,"generator":false,"comments":"Removes runtime caches for old versions of the api.  This ensures that all responses\nare appropriate for the current version of the UI.","examples":[],"params":[],"returns":[],"import":"import { removeOldCaches } from 'react-storefront/router/serviceWorker'"},"router/withGlobalState":{"name":"withGlobalState","type":"function","async":true,"generator":false,"comments":"When doing SSR, returns globalState and localState merged.  When responding to an AJAX\nrequest, only returns localState.\n\nExample:\n\n function productHandler({ id }, state, request) {\n   const product = {} // get product info from upstream API\n   const globalState = () => fetchMenuData() // async function that makes an api call to get menu data.  Will only be called during ssr\n   return withGlobalState(request, globalState, product)\n }","examples":[],"params":[{"name":"request","type":"Object","text":"The request object passed into the handler"},{"name":"globalState","type":"Object/Function","text":"An object containing data that is needed for all landing pages, such as menu items, navigation, etc..., or a function that returns this data."},{"name":"localState","type":"Object","text":"The state being returned for the specific URL being handled"}],"returns":[{"type":"Object"}],"import":"import withGlobalState from 'react-storefront/router/withGlobalState'"},"utils/browser/isSafari":{"name":"isSafari","type":"function","async":false,"generator":false,"comments":"Returns true only in Safari","examples":[],"params":[],"returns":[{"type":"Boolean"}],"import":"import { isSafari } from 'react-storefront/utils/browser'"},"utils/createGenerateClassName":{"name":"createGenerateClassName","type":"function","async":false,"generator":false,"comments":"Creates a class name generator for JSS.\nAdapted from https://github.com/cssinjs/jss/blob/master/src/utils/createGenerateClassName.js","examples":[],"params":[{"name":"amp","default":"false","type":"Boolean","text":"Set to true when rendering amp.  When true, the smaller production class names will be used so\n you can tell for sure whether or not your stylesheet is small enough to meet amp's size limit.","properties":[{"name":"amp","default":"false"}]}],"returns":[{"type":"Function"}],"import":"import createGenerateClassName from 'react-storefront/utils/createGenerateClassName'"},"utils/dataProps":{"name":"dataProps","type":"function","async":false,"generator":false,"comments":"Returns an object containing the values from props corresponding to keys that start with \"data-\"","examples":[],"params":[{"name":"props","type":"Object"}],"returns":[{"type":"Object"}],"import":"import dataProps from 'react-storefront/utils/dataProps'"},"utils/optimizeImages":{"name":"optimizeImages","type":"function","async":false,"generator":false,"comments":"Transforms images within the given HTML to come from the Moovweb Image Optimizer","examples":[],"params":[{"name":"html","type":"String","text":"Input HTML"},{"name":"options","type":"Object","text":"Transformation options"}],"returns":[{"type":"String","text":"Optimized HTML"}],"import":"import optimizeImages from 'react-storefront/utils/optimizeImages'"},"utils/scriptInjector/injectScriptInHead":{"name":"injectScriptInHead","type":"function","async":false,"generator":false,"comments":"Method for injecting script tag in <head>","examples":[],"params":[{"name":"src","type":"String","text":"path to script"},{"name":"params","default":"{}","type":"Object","text":"Optional params","properties":[{"name":"attrs","default":"{}","type":"Object","text":"Optional attributes to add to element"},{"name":"once","default":"true","type":"Boolean","text":"If true then script will be injected only once"}]}],"returns":[{"type":"Promise","text":"Promise returns on script's onload event"}],"import":"import { injectScriptInHead } from 'react-storefront/utils/scriptInjector'"},"utils/scriptInjector/injectCodeInHead":{"name":"injectCodeInHead","type":"function","async":false,"generator":false,"comments":"Method for injecting target code in <head>","examples":[],"params":[{"name":"code","type":"String","text":"script code"},{"name":"params","default":"{}","type":"Object","text":"optional params","properties":[{"name":"once","default":"false","type":"Boolean","text":"If true then script will be injected only once"}]}],"returns":[],"import":"import { injectCodeInHead } from 'react-storefront/utils/scriptInjector'"},"utils/scriptInjector/removeScriptInHead":{"name":"removeScriptInHead","type":"function","async":false,"generator":false,"comments":"Method for removing script in <head>","examples":[],"params":[{"name":"src","type":"String","text":"path to script"}],"returns":[],"import":"import { removeScriptInHead } from 'react-storefront/utils/scriptInjector'"},"utils/scriptInjector/removeCodeInHead":{"name":"removeCodeInHead","type":"function","async":false,"generator":false,"comments":"Method for removing code  in <head>","examples":[],"params":[{"name":"code","type":"String","text":"script code"}],"returns":[],"import":"import { removeCodeInHead } from 'react-storefront/utils/scriptInjector'"},"utils/state/lazyState":{"name":"lazyState","type":"function","async":false,"generator":false,"comments":"If the provided object is a string, returns a function that parses the string as JSON,\notherwise returns the provided object.","examples":[],"params":[{"name":"state"}],"returns":[{}],"import":"import { lazyState } from 'react-storefront/utils/state'"},"utils/state/parseState":{"name":"parseState","type":"function","async":false,"generator":false,"comments":"If the provided object is a string, parses it as JSON and returns the resulting object,\notherwise returns the provided object.","examples":[],"params":[{"name":"state"}],"returns":[{"type":"Object"}],"import":"import { parseState } from 'react-storefront/utils/state'"},"utils/url/relativeURL":{"name":"relativeURL","type":"function","async":false,"generator":false,"comments":"Strips the protocol and hostname from the URL, returning a relative URL.","examples":[{"description":"import { relativeURL } from 'react-storefront/utils/url'\n\nrelativeURL('https://www.domain.com/path/to/page') // returns \"/path/to/page\"","caption":"Example usage of relativeURL"}],"params":[{"name":"url","type":"String","text":"An absolute or relative URL"}],"returns":[{"type":"String","text":"A relative URL"}],"import":"import { relativeURL } from 'react-storefront/utils/url'"},"utils/url/absoluteURL":{"name":"absoluteURL","type":"function","async":false,"generator":false,"comments":"Creates an absolute URL for the given URL","examples":[],"params":[{"name":"url","type":"String","text":"A relative URL"},{"name":"currentLocation","default":"{}","type":"LocationModel","text":"The current browser location","properties":[{"name":"protocol"},{"name":"hostname"},{"name":"port"},{"name":"pathname"}]}],"returns":[{"type":"String","text":"An absolute URL"}],"import":"import { absoluteURL } from 'react-storefront/utils/url'"},"utils/url/canUseClientSideNavigation":{"name":"canUseClientSideNavigation","type":"function","async":false,"generator":false,"comments":"Returns true if a URL can be navigated to on the client using history.push","examples":[],"params":[{"name":"url","type":"String","text":"The URL to check"},{"name":"router","type":"String","text":"The router"}],"returns":[{"type":"Boolean"}],"import":"import { canUseClientSideNavigation } from 'react-storefront/utils/url'"}}};
export default data;